use work.instructions.all;

package indexed_addressing_mixin is
    generic ( type parent_instruction is new instruction with private );
    
    type indexed_instruction is
        new parent_instruction with record
            index_base, index_offset : register_number;
        end record indexed_instruction;
    
    function effective_address ( instr : indexed_instruction ) return integer;
    
end package indexed_addressing_mixin;
