package network_level is
    
    use work.MAC_level.MAC_packet;

    type network_level_address is new natural;
    type control_type is ( control_1, control_2, control_3 );
    subtype hop_count is natural;

    type network_packet is
        new MAC_packet with private;
    
    procedure set_network_dest ( pkt : inout network_packet;
                                 dest : in network_level_address );

private
    
    type network_packet is
        new MAC_packet with record
            source, dest : network_level_address;
            control : control_type;
            time_to_live : hop_count;
        end record network_packet;
    
end package network_level;
