package body instructions is

    function privileged ( instr : instruction;
                          mode : protection_mode ) return boolean is
    begin
        case instr.opcode is
            when rfe =>
                return true;
            when others =>
                return false;
        end case;
    end function privileged;
    
    
    procedure disassemble ( instr : instruction;  L : inout line ) is
    begin
        write ( L, opcode_type'image(instr.opcode) );
    end procedure disassemble;

    
    procedure disassemble_reg ( reg : register_number;  L : inout line ) is
    begin
        write ( L, 'R' );
        write ( L, register_number'image(reg) );
    end procedure disassemble_reg;

    
    function read_register ( reg : register_number ) return integer is
    begin
        return 0;
    end function read_register;


end package body instructions;
